package com.its.api.its.service.road;

import com.its.api.its.model.dto.road.TbRoadVrtxArrDto;
import com.its.api.its.model.entity.road.TbRoadVrtxArr;
import com.its.api.its.model.entity.road.TbRoadVrtxArrKey;
import com.its.api.its.repository.road.TbRoadVrtxArrRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbRoadVrtxArrService {

    private final TbRoadVrtxArrRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbRoadVrtxArr requireOne(TbRoadVrtxArrKey id) {
        return this.repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbRoadVrtxArrDto> findAll() {
        List<TbRoadVrtxArrDto> result = new ArrayList<>();
        List<TbRoadVrtxArr> data = this.repo.findAll();
        for (TbRoadVrtxArr entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbRoadVrtxArrDto findById(TbRoadVrtxArrKey id) {
        TbRoadVrtxArr entity = requireOne(id);
        return entity.toDto();
    }

    /**
     * 레벨에 따른 버텍스 정보 조회
     * @param levl
     * @return
     */
    public List<TbRoadVrtxArrDto> findAllByLevl(Integer levl) {
        List<TbRoadVrtxArrDto> result = new ArrayList<>();
        List<TbRoadVrtxArr> data = this.repo.findAllByLevl(levl);
        data.forEach(obj -> {
            result.add(obj.toDto());
        });
        return result;
    }
}
